<template lang="pug">
  div.mb-12
    v-card.mb-12
      v-card-title Trenchs
      v-card-text
        v-data-table(
          :headers="headers"
          :items="getAllTrench.data"
          :items-per-page="10"
          class="elevation-0"
          v-model="selected"
          show-select
          single-select
          @click:row="rowClick"
        )
        v-btn#deleteTrenchButton.float-left(
          color="warning"
        ) Delete
        v-btn#editTrenchButton.float-right(
          @click="setEditTrench"
          color="success"
        ) Edit
      v-fab-transition
        v-btn#newTrenchButton(
          color="success"
          bottom
          right
          large
          fixed
          fab
        )
          v-icon mdi-plus-circle-outline
    v-dialog(
      v-model="showModal"
      activator="#newTrenchButton"
      persistent
    )
      v-card
        v-card-title New Trench
        v-card-text
          v-text-field(
            label="Trench Number"
            v-model.number="newTrench.number"
          )
          div.d-flex
            v-btn.ml-auto(
              color="warning"
              @click="showModal = false"
            ) Cancel
            v-btn.ml-3(
              color="success"
              @click="saveNewTrench"
            ) Save
    v-dialog(
      v-model="showEditModal"
      activator="#editSiteButton"
      persistent
    )
      v-card
        v-card-title Edit Trench
        v-card-text
          v-text-field(
            label="Site Number"
            v-model.number="editTrench.number"
          )
          v-textarea(
            label="Location"
            v-model="editTrench.location"
          )
          div.d-flex
            v-btn.ml-auto(
              color="warning"
              @click="showEditModal = false"
            ) Cancel
            v-btn.ml-3(
              color="success"
              @click="saveEditTrench"
            ) Save
    v-dialog(
      v-model="areYouSure"
      activator="#deleteTrenchButton"
    )
      v-card
        v-card-title Are You Sure?
        v-card-text Deleting a Trench removes all associated Contexts and
          b cannot be undone!
          div.d-flex.mt-3
            v-btn(
              color="success"
              @click="areYouSure = false"
            ) No! Don"t Delete!
            v-btn.ml-auto(
              color="warning"
              @click="deleteTrench"
            ) I"m Sure.
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
    name: "trench-collection",
    props: {
        projectid: {
            required: true,
            type: String
        },
        siteid: {
            required: true,
            type: String
        }
    },
    data() {
        return {
            headers: [{ text: "Trench Number", value: "attributes.number" }],
            selected: [],
            notification: "",
            snackbar: false,
            areYouSure: false,
            showEditModal: false,
            showModal: false,
            newTrench: {
                number: "",
                site: "",
                project: ""
            },
            editTrench: {
                number: "",
                site: "",
                project: ""
            }
        };
    },
    created() {
        this.$store.dispatch("getCurrentURL", {
            projectID: this.projectid,
            siteID: this.siteid
        });
    },
    computed: {
        ...mapGetters({
            getAProject: "project/getAProject",
            getASite: "site/getASite",
            getAllTrench: "trench/getAllTrench"
        })
    },
    methods: {
        ...mapActions({
            fetchAllTrench: "trench/fetchAllTrench",
            putATrench: "trench/putATrench",
            createATrench: "trench/createATrench",
            deleteATrench: "trench/deleteATrench"
        }),
        rowClick(row) {
            this.$router.push({ path: `trenchs/${row.id}/contexts` });
        },
        setEditTrench() {
            if (this.selected.length > 0) {
                this.editTrench.number = this.selected[0].attributes.number;
                this.editTrench.site = this.selected[0].attributes.site;
                this.editTrench.project = this.selected[0].attributes.project;
                this.showEditModal = true;
            } else {
                this.$store.dispatch("setNotification", "No Trench Selected");
            }
        },
        saveNewTrench() {
            this.newTrench.site = this.getASite.data.id;
            this.newTrench.project = this.getAProject.data.id;
            this.createATrench({
                url: this.getAllTrench.links.self,
                payload: this.newTrench
            }).then(response => {
                this.$store.commit("setNotification", "Trench Created");
                this.fetchAllTrench({
                    url: this.getAllTrench.links.self
                });
                this.showModal = false;
            });
        },
        saveEditTrench() {
            this.putATrench({
                url: this.selected[0].links.self,
                payload: this.editTrench
            }).then(response => {
                this.$store.commit("setNotification", "Trench Saved");
                this.fetchAllTrench({
                    url: this.getAllTrench.links.self
                });
                this.showEditModal = false;
            });
        },
        deleteTrench() {
            if (this.selected.length > 0) {
                this.deleteATrench(this.selected[0].links.self).then(
                    response => {
                        this.areYouSure = false;
                        this.$store.commit("setNotification", "Trench Deleted");
                        this.fetchAllTrench({
                            url: this.getAllTrench.links.self
                        });
                    }
                );
            } else {
                this.$store.commit("setNotification", "No Trench Selected");
                this.areYouSure = false;
            }
        }
    }
};
</script>
